# CEB
a Cluster Ensemble Based method for identifying cell-types.

## Introduction
Cell-type identification is an important issue in the analysis of single-cell data. Currently, the research on cell-type identification mainly uses single-cell transcriptome data. However, other omics data also play an important role in the identification of cell types. Here we provide a software tool that integrates single-cell multi-omics data to identify cell types. It integrates the results of multiple omics data on multiple single-cell clustering algorithms through late integration. CEB method has high accuracy and robustness.
CEB consists of four components, including Data Processing, Individual Cluatering, Clustering Ensemble.

## The package
CEB depends on multiple packages, including mclust, fpc, vegan, apcluster, factoextra, ADPclust, SC3, SingleCellExperiment, Rtsne, kernlab.
To make sure all the dependency packages are installed.

Download CEB_0.1.1.tar.gz
Install R package locally from R studio.

## Data Input
Data input provides the interface for users to upload data for the construction of CEB.

### RNA data
The expression profiles of single-cell RNA data. The rows of uploaded files should represent RNA, while the columns should represent samples.
#### RNA Expression Profile Samples

### Methylation data
The expression profiles of single-cell DNA methylation data. The rows of uploaded files should represent DNA methylation rates (from 0 to 1) summarised at the feature level (i.e. promotes, gene bodies, etc.), while the columns should represent samples.

Just upload the data and parameters to get the result.
```
CEB_result <- CEB(dataset_list, feature.filter = T, feature.filter.fraction = 0.06, 
                  datatype = "count", log.trans = F,
                  SC3 = T, gene_filter = F, svm_num_cells = 5000, 
                  tSNE = T, dimensions = 3, perplexity = 30, tsne_min_cells = 200, 
                  tsne_min_perplexity = 10, var_genes = NULL,
                  kmeans = T, iter.max = 100,
                  spectral_cluster = T,
                  DBSCAN = F, eps = 270, MinPts = 5,
                  hierarchical_clustering = F, distance_form = "euclidean",
                  SEED = 1)
```

## Reports
Here, we present reports generated by CEB. CEB reports the results of cell-type identifying, and the results can be evaluated by external index if we have the ground truth of cell-types.
